module Rats
  class Base

    # TODO: this data needs to be updated to list the sections where not
    #       all quarters are valid, and list whoch ones are.

    # this array doesn't define what is valid, but trys to define what
    # combinations of meridian/range/township/section exist
    #

    # format
    # VALID_MERIDIAN => {
    #   # NOTE: any RANGE not listed here, does not exist
    #   # NOTE: any TOWNSHIP not within the VALID_TOWNSHIP_RANGE does not exist
    #   RANGE => { :townships => VALID_TOWNSHIP_RANGE,
    #     :sections => {
    #       # NOTE: a TOWNSHIP not included here means all sections are valid within
    #       # NOTE: for a TOWNSHIP listed here, only a SECTION within
    #       #   ARRAY_OF_VALID_SECTIONS is valid
    #       VALID_TOWNSHIP => ARRAY_OF_VALID_SECTIONS
    #     },
    #     # NOTE: a SECTION not included here means all QUARTERs are valid within
    #     # NOTE: for a SECTION listed here, only a QUARTER within
    #     #   ARRAY_OF_VALID_QUARTERS is valid
    #     VALID_SECTION => ARRAY_OF_VALID_QUARTERS
    #   }
    # }

    # proposed format (allows for quarters to be listed)
    #
    # TOWNSHIPS_BY_RANGE_AND_MERIDIAN = {
    #   # only valid meridian listed here
    #   4 => {
    #     # only valid ranges listed here
    #     1 => {
    #       # only valid township range listed here
    #       :townships => 1..126
    #       # no specifics past this, means all sections and quarters are valid
    #     },
    #     # another valid range
    #     21 => {
    #       # only valid townships listed here
    #       :townships => 1..126,
    #       # list exceptions specific to certain townships
    #       :township => {
    #         # township listed here has exceptions, otherwise treat as normal
    #         3 => {
    #           # only valid sections listed here
    #           :sections => [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,17,18,19,22,23,24,25,26,27,28,31,32,33,34,35,36],
    #           # list exceptions specific to certain sections
    #           :section => {
    #             # section listed here has exceptions, otherwise treat as normal
    #             36 => {
    #               # only valid quarters listed here
    #               :quarters => [:ne, :se]
    #             }
    #           }
    #         }
    #       }
    #     }
    #   }
    # }

    TOWNSHIPS_BY_RANGE_AND_MERIDIAN = {
      4 => {
        1 => { :townships => 1..126 },
        2 => { :townships => 1..126 },
        3 => { :townships => 1..126 },
        4 => { :townships => 1..126 },
        5 => { :townships => 1..126 },
        6 => { :townships => 1..126 },
        7 => { :townships => 1..126 },
        8 => { :townships => 1..126 },
        9 => { :townships => 1..126 },
        10 => { :townships => 1..126 },
        11 => { :townships => 1..126 },
        12 => { :townships => 1..126 },
        13 => { :townships => 1..126 },
        14 => { :townships => 1..126 },
        15 => { :townships => 1..126 },
        16 => { :townships => 1..126 },
        17 => { :townships => 1..126 },
        18 => { :townships => 1..126 },
        19 => { :townships => 1..126 },
        20 => { :townships => 1..126 },
        21 => { :townships => 1..126,
          :sections => {
            3 => [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,17,18,19,22,23,24,25,26,27,28,31,32,33,34,35,36],
          }
        },
        22 => { :townships => 1..126 },
        23 => { :townships => 1..126 },
        24 => { :townships => 1..122,
          :sections => {
            111 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            112 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            113 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            114 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            115 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            116 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            117 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            118 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            119 => [1,12,13,24,25,36],
            120 => [1,12,13,23,24,25,26,35,36],
            121 => [1,2,11,12,13,14,23,24,25,26,35,36],
            122 => [1,2,11,12,13,14,23,24,25,26,35,36],
          }
        },
        25 => { :townships => 1..106,
          :sections => {
            91 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            92 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            93 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            94 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            95 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            96 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            97 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            98 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            99 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            100 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            101 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            102 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            103 => [1,12,13,24,25,36],
            104 => [1,12,13,24,25,36],
            105 => [1,12,13,24,25,36],
            106 => [1,12,13,24,25,36],
          }
        },
        26 => { :townships => 1..90,
          :sections => {
            75 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            76 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            77 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            78 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            79 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            80 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            81 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            82 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            83 => [1,2,11,12,13,14,23,24,25,26,35,36],
            84 => [1,2,11,12,13,14,23,24,25,26,35,36],
            85 => [1,2,11,12,13,14,23,24,25,26,35,36],
            86 => [1,2,11,12,13,14,23,24,25,26,35,36],
            87 => [1,12,13,24,25,36],
            88 => [1,12,13,24,25,36],
            89 => [1,12,13,24,25,36],
            90 => [1,12,13,24,25,36],
          }
        },
        27 => { :townships => 1..70,
          :sections => {
            59 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            60 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            61 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            62 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            63 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            64 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            65 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            66 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            67 => [1,2,11,12,13,14,23,24,25,26,35,36],
            68 => [1,2,11,12,13,14,23,24,25,26,35,36],
            69 => [1,2,11,12,13,14,23,24,25,26,35,36],
            70 => [1,2,11,12,13,14,23,24,25,26,35,36],
          }
        },
        28 => { :townships => 1..54,
          :sections => {
            39 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            40 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            41 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            42 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            43 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            44 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            45 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            46 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            47 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            48 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            49 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            50 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            51 => [1,12,13,24,25,36],
            52 => [1,12,13,24,25,36],
            53 => [1,12,13,24,25,36],
            54 => [1,12,13,24,25,36],
          }
        },
        29 => { :townships => 1..34,
          :sections => {
            23 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            24 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            25 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            26 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            27 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            28 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            29 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            30 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            31 => [1,2,11,12,13,14,23,24,25,26,35,36],
            32 => [1,2,11,12,13,14,23,24,25,26,35,36],
            33 => [1,2,11,12,13,14,23,24,25,26,35,36],
            34 => [1,2,11,12,13,14,23,24,25,26,35,36],
          }
        },
        30 => { :townships => 1..18,
          :sections => {
            3 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            4 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            5 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            6 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            7 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            8 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            9 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            10 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            11 => [1,2,11,12,13,14,23,24,25,26,35,36],
            12 => [1,2,11,12,13,14,23,24,25,26,35,36],
            13 => [1,2,11,12,13,14,23,24,25,26,35,36],
            14 => [1,2,11,12,13,14,23,24,25,26,35,36],
            15 => [1,12,13,24,25,36],
            16 => [1,12,13,24,25,36],
            17 => [1,12,13,24,25,36],
            18 => [1,12,13,24,25,36],
          }
        },
      },
      5 => {
        1 => { :townships => 1..126 },
        2 => { :townships => 1..126 },
        3 => { :townships => 1..126 },
        4 => { :townships => 1..126 },
        5 => { :townships => 1..126,
          :sections => {
            1 => [1,2,12,13,24,25,36],
            2 => [1,12,13,24,25,36],
            3 => [1,12,13,24,25,36],
            4 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        6 => { :townships => 4..126,
          :sections => {
            4 => [36],
            5 => [1,12,13,24,25,36],
            6 => [1,12,13,24,25,36],
          }
        },
        7 => { :townships => 7..126,
          :sections => {
            7 => [1,12,13,24,25,36],
            8 => [1,12,13,24,25,36],
            9 => [1,12,13,24,25,36],
            10 => [1,12,13,24,25,36],
            11 => [1,12,13,24,25,36],
            12 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        8 => { :townships => 12..126,
          :sections => {
            12 => [36],
            13 => [1,12,13,24,25,36],
            14 => [1,12,13,24,25,36],
            15 => [1,12,13,24,25,36],
            16 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        9 => { :townships => 16..126,
          :sections => {
            16 => [31,32,33,34,35,36],
          }
        },
        10 => { :townships => 16..126,
          :sections => {
            16 => [31,32,33,34,35,36],
          }
        },
        11 => { :townships => 16..126,
          :sections => {
            16 => [31,32,33,34,35,36],
          }
        },
        12 => { :townships => 16..126,
          :sections => {
            16 => [36],
            17 => [1,12,13,24,25,36],
            18 => [1,12,13,24,25,36],
            19 => [1,12,13,24,25,36],
            20 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        13 => { :townships => 20..126,
          :sections => {
            20 => [31,32,33,34,35,36],
          }
        },
        14 => { :townships => 20..126,
          :sections => {
            20 => [31,32,33,34,35,36],
          }
        },
        15 => { :townships => 20..126,
          :sections => {
            20 => [36],
            21 => [1,12,13,24,25,36],
            22 => [1,12,13,24,25,36],
            23 => [1,12,13,24,25,36],
            24 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        16 => { :townships => 24..126,
          :sections => {
            24 => [31,32,33,34,35,36],
          }
        },
        17 => { :townships => 24..126,
          :sections => {
            24 => [31,32,33,34,35,36],
          }
        },
        18 => { :townships => 24..126,
          :sections => {
            24 => [36],
            25 => [1,12,13,24,25,36],
            26 => [1,12,13,24,25,36],
            27 => [1,12,13,24,25,36],
            28 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        19 => { :townships => 28..126,
          :sections => {
            28 => [31,32,33,34,35,36],
          }
        },
        20 => { :townships => 28..126,
          :sections => {
            28 => [31,32,33,34,35,36],
          }
        },
        21 => { :townships => 28..126,
          :sections => {
            28 => [31,32,33,34,35,36],
          }
        },
        22 => { :townships => 28..126,
          :sections => {
            28 => [36],
            29 => [1,12,13,24,25,36],
            30 => [1,12,13,24,25,36],
            31 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        23 => { :townships => 31..126,
          :sections => {
            31 => [36],
            32 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        24 => { :townships => 32..122,
          :sections => {
            32 => [31,32,33,34,35,36],
            111 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            112 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            113 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            114 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            115 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            116 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            117 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            118 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            119 => [1,2,11,12,13,14,23,24,25,26,35,36],
            120 => [1,2,11,12,13,14,23,24,25,26,35,36],
            121 => [1,2,11,12,13,14,23,24,25,26,35,36],
            122 => [1,2,11,12,13,14,23,24,25,26,35,36],
          }
        },
        25 => { :townships => 32..106,
          :sections => {
            32 => [31,32,33,34,35,36],
            91 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            92 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            93 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            94 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            95 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            96 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            97 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            98 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            99 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            100 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            101 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            102 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            103 => [1,12,13,24,25,36],
            104 => [1,12,13,24,25,36],
            105 => [1,12,13,24,25,36],
            106 => [1,12,13,24,25,36],
          }
        },
        26 => { :townships => 32..90,
          :sections => {
            32 => [31,32,33,34,35,36],
            75 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            76 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            77 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            78 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            79 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            80 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            81 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            82 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            83 => [1,2,11,12,13,14,23,24,25,26,35,36],
            84 => [1,2,11,12,13,14,23,24,25,26,35,36],
            85 => [1,2,11,12,13,14,23,24,25,26,35,36],
            86 => [1,2,11,12,13,14,23,24,25,26,35,36],
            87 => [1,12,13,24,25,36],
            88 => [1,12,13,24,25,36],
            89 => [1,12,13,24,25,36],
            90 => [1,12,13,24,25,36],
          }
        },
        27 => { :townships => 32..70,
          :sections => {
            32 => [31,32,33,34,35,36],
            59 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            60 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            61 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            62 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            63 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            64 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            65 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            66 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            67 => [1,2,11,12,13,14,23,24,25,26,35,36],
            68 => [1,2,11,12,13,14,23,24,25,26,35,36],
            69 => [1,2,11,12,13,14,23,24,25,26,35,36],
            70 => [1,2,11,12,13,14,23,24,25,26,35,36],
          }
        },
        28 => { :townships => 32..54,
          :sections => {
            32 => [31,32,33,34,35,36],
            39 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            40 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            41 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            42 => [1,2,3,4,5,8,9,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,32,33,34,35,36],
            43 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            44 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            45 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            46 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            47 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            48 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            49 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            50 => [1,2,3,10,11,12,13,14,15,22,23,24,25,26,27,34,35,36],
            51 => [1,12,13,24,25,36],
            52 => [1,12,13,24,25,36],
            53 => [1,12,13,24,25,36],
            54 => [1,12,13,24,25,36],
          }
        },
        29 => { :townships => 32..38,
          :sections => {
            32 => [36],
            33 => [1,12,13,24,25,36],
            34 => [1,12,13,24,25,36],
            35 => [1,12,13,24,25,36],
            36 => [1,12,13,24,25,36],
            37 => [1,12,13,24,25,36],
            38 => [1,12,13,24,25,36],
          }
        },
      },
      6 => {
        1 => { :townships => 35..126,
          :sections => {
            35 => [1,12,13,24,25,36],
            36 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        2 => { :townships => 36..126,
          :sections => {
            36 => [31,32,33,34,35,36],
          }
        },
        3 => { :townships => 36..126,
          :sections => {
            36 => [36],
            37 => [1,12,13,24,25,36],
            38 => [1,12,13,24,25,36],
            39 => [1,12,13,24,25,36],
            40 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        4 => { :townships => 40..126,
          :sections => {
            40 => [31,32,33,34,35,36],
          }
        },
        5 => { :townships => 40..126,
          :sections => {
            40 => [36],
            41 => [1,12,13,24,25,36],
            42 => [1,12,13,24,25,36],
            43 => [1,12,13,24,25,36],
            44 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        6 => { :townships => 44..126,
          :sections => {
            44 => [31,32,33,34,35,36],
          }
        },
        7 => { :townships => 44..126,
          :sections => {
            44 => [31,32,33,34,35,36],
          }
        },
        8 => { :townships => 44..126,
          :sections => {
            44 => [31,32,33,34,35,36],
          }
        },
        9 => { :townships => 44..126,
          :sections => {
            44 => [31,32,33,34,35,36],
          }
        },
        10 => { :townships => 44..126,
          :sections => {
            44 => [36],
            45 => [1,12,13,24,25,36],
            46 => [1,12,13,24,25,36],
            47 => [1,12,13,24,25,36],
            48 => [1,12,13,24,25,31,32,33,34,35,36],
          }
        },
        11 => { :townships => 48..126,
          :sections => {
            48 => [31,32,33,34,35,36],
          }
        },
        12 => { :townships => 48..126,
          :sections => {
            48 => [31,32,33,34,35,36],
          }
        },
        13 => { :townships => 48..126,
          :sections => {
            48 => [31,32,33,34,35,36],
            115 => [1,12,13,24,25,36],
            116 => [1,12,13,24,25,36],
            117 => [1,12,13,24,25,36],
            118 => [1,12,13,24,25,36],
            119 => [1,12,13,24,25,36],
            120 => [1,12,13,24,25,36],
            121 => [1,12,13,24,25,36],
            122 => [1,12,13,24,25,36],
            123 => [1,12,13,24,25,36],
            124 => [1,12,13,24,25,36],
            125 => [1,12,13,24,25,36],
            126 => [1,12,13,24,25,36],
          }
        },
        14 => { :townships => 48..114,
          :sections => {
            48 => [31,32,33,34,35,36],
            75 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            76 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            77 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            78 => [1,2,3,4,9,10,11,12,13,14,15,16,21,22,23,24,25,26,27,28,33,34,35,36],
            79 => [1,12,13,24,25,36],
            80 => [1,12,13,24,25,36],
            81 => [1,12,13,24,25,36],
            82 => [1,12,13,24,25,36],
            83 => [1,12,13,24,25,36],
            84 => [1,12,13,24,25,36],
            85 => [1,12,13,24,25,36],
            86 => [1,12,13,24,25,36],
            87 => [1,12,13,24,25,36],
            88 => [1,12,13,24,25,36],
            89 => [1,12,13,24,25,36],
            90 => [1,12,13,24,25,36],
            91 => [1,12,13,24,25,36],
            92 => [1,12,13,24,25,36],
            93 => [1,12,13,24,25,36],
            94 => [1,12,13,24,25,36],
            95 => [1,12,13,24,25,36],
            96 => [1,12,13,24,25,36],
            97 => [1,12,13,24,25,36],
            98 => [1,12,13,24,25,36],
            99 => [1,12,13,24,25,36],
            100 => [1,12,13,24,25,36],
            101 => [1,12,13,24,25,36],
            102 => [1,12,13,24,25,36],
            103 => [1,12,13,24,25,36],
            104 => [1,12,13,24,25,36],
            105 => [1,12,13,24,25,36],
            106 => [1,12,13,24,25,36],
            107 => [1,12,13,24,25,36],
            108 => [1,12,13,24,25,36],
            109 => [1,12,13,24,25,36],
            110 => [1,12,13,24,25,36],
            111 => [1,12,13,24,25,36],
            112 => [1,12,13,24,25,36],
            113 => [1,12,13,24,25,36],
            114 => [1,12,13,24,25,36],
          }
        },
        15 => { :townships => 48..78,
          :sections => {
            48 => [36],
            49 => [1,12,13,24,25,36],
            50 => [1,12,13,24,25,36],
            51 => [1,12,13,24,25,36],
            52 => [1,12,13,24,25,36],
            53 => [1,12,13,24,25,36],
            54 => [1,12,13,24,25,36],
            55 => [1,12,13,24,25,36],
            56 => [1,12,13,24,25,36],
            57 => [1,12,13,24,25,36],
            58 => [1,12,13,24,25,36],
            59 => [1,12,13,24,25,36],
            60 => [1,12,13,24,25,36],
            61 => [1,12,13,24,25,36],
            62 => [1,12,13,24,25,36],
            63 => [1,12,13,24,25,36],
            64 => [1,12,13,24,25,36],
            65 => [1,12,13,24,25,36],
            66 => [1,12,13,24,25,36],
            67 => [1,12,13,24,25,36],
            68 => [1,12,13,24,25,36],
            69 => [1,12,13,24,25,36],
            70 => [1,12,13,24,25,36],
            71 => [1,12,13,24,25,36],
            72 => [1,12,13,24,25,36],
            73 => [1,12,13,24,25,36],
            74 => [1,12,13,24,25,36],
            75 => [1,36],
            76 => [36],
            77 => [36],
            78 => [36],
          }
        },
      }
    }

  end
end
